/*********************************************************************
/*** signumber.c
/*** Copyright (c) 2001 by Markus Winand <mws@fatalmind.com>
/*** $Id: signumber.c,v 1.2 2001/06/29 19:22:52 mws Exp $
/********************************************************************/

#ifdef HAVE_CONFIG_H
	#include "config.h"
#endif

#include <stdio.h>
#include "hatimerun.h"

#ifndef HAVE_SYS_SIGNAME

#ifdef HATOOLS_SYS_SIGNAME_H
	#include "sys_signame.h"
#else
	#include "sys_signame_posix.h"
#endif

#include <string.h>

int signumber(const char *signame) {
	int signum = 0;
	int i = 1;

	if (! strncasecmp(signame, "SIG", 3)) {
		signame += 3;
	}
	
	while (signum == 0 && sys_signame2[i] != NULL) {
		if (! strcasecmp(signame, sys_signame2[i])) {
			signum = sys_signumber2[i];
		}
		i++;
	}
	return signum;	
}

void siglist() {
	int i;

	for (i = 0; sys_signame2[i] != NULL; i++) {
		fprintf(stderr, "SIG%s\n", sys_signame2[i]);
	}
	exit (FAIL_EXITCODE);
}
#else

#include <signal.h>
int signumber(const char *signame) {
	int i;
	int signum = 0;
	
	if (! strncasecmp(signame, "SIG", 3)) {
		signame += 3;
	}

	for (i = 0; (i < NSIG) && (signum == 0); i++) {
		if (! strcasecmp(signame, sys_signame[i])) {
			signum = i;
		}
	}
	return signum;
}

void sig_printUC(const char *signame) {
	int i = 0;

	fprintf(stderr, "SIG");
	while (signame[i] != NULL) {
		fputc(toupper(signame[i]), stderr);
		i++;
	}
	fputc('\n', stderr);
	
}

void siglist() {
	int i;

	for (i = 0; i < NSIG; i++) {
		sig_printUC(sys_signame[i]);
//		fprintf(stderr, "SIG%s\n", sys_signame[i]);
	}
	exit (FAIL_EXITCODE);
};

#endif
